/* $Id: gencrctbl.c 7599 2013-04-22 13:57:32Z chris $ */

#include <inttypes.h>
#include <stdio.h>

int main(void) {
  const uint16_t key = 0x1021;
  uint16_t table[256];

  int byte, byte_tmp, i;
  uint16_t tmp;

  for (byte = 0; byte < 256; byte++) {

    byte_tmp = byte << 8;
    tmp = 0x0;

    for (i = 0; i < 8; i++, byte_tmp <<= 1) {
      tmp = (tmp << 1) ^ (((byte_tmp ^ tmp) & 0x8000) ? key : 0);
    }

    table[byte] = tmp;

  }

  fprintf(stdout, "/* $" "Id" "$ */\n");
  fprintf(stdout, "\n");
  fprintf(stdout, "#include <stdint.h>\n");
  fprintf(stdout, "\n");
  fprintf(stdout, "const uint16_t crctbl[] = {\n");
  for (byte = 0; byte < 256; byte += 8) {
    fprintf(stdout,
            "  0x%04" PRIx16 ", 0x%04" PRIx16 ", 0x%04" PRIx16 ", 0x%04" PRIx16
            ", 0x%04" PRIx16 ", 0x%04" PRIx16 ", 0x%04" PRIx16 ", 0x%04" PRIx16 ",\n",
            table[byte+0], table[byte+1], table[byte+2], table[byte+3],
            table[byte+4], table[byte+5], table[byte+6], table[byte+7]);
  }
  fprintf(stdout, "};\n");

  return 0;
}
