/* $Id: scsi.c 7623 2013-05-06 12:48:48Z chris $ */

#include "scsi.h"

int read_sector_raw_subchannels(device_handle handle, size_t sector, size_t sector_count, uint8_t *data)
{
  uint8_t cdb[12]; //CDB size is 12 for ReadCD MMC1 command

  //CDB with values for ReadCD CDB12 command.  The values were taken from MMC1 draft paper.
  cdb[0]=0xBE;  //Code for ReadCD CDB12 command
  cdb[1]=0;

  cdb[2] = (sector >> 24) & 0xff;
  cdb[3] = (sector >> 16) & 0xff;
  cdb[4] = (sector >>  8) & 0xff;
  cdb[5] = (sector >>  0) & 0xff;

  cdb[6] = (sector_count >> 16) & 0xff;
  cdb[7] = (sector_count >>  8) & 0xff;
  cdb[8] = (sector_count >>  0) & 0xff;

  cdb[9]=0;  // No main channel data
  cdb[10]=1;  //Selects read RAW 96 bytes/sector sub-channel data
  cdb[11]=0;

  return scsi_cmd(handle, cdb, sizeof cdb, data, sector_count * 96);
}
